> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/appian/smart-services/logging.md).

# Capturing smart service logs from smart services in Appian

Learn how to capture smart service logs from smart services in Appian using custom logging. This guide provides step-by-step instructions on adding custom logging and reading the output in tomcat logs

Smart Services provided by our PDFNet library can be extremely useful in process models and expressions, however, they can seem like a black box. Outside of error feedback when something goes wrong, we cannot see into the activities of the smart service. If we want to get more details on the exact details on what is being called or used, then we will need to use [custom logging](https://docs.appian.com/suite/help/24.4/Customizing_Application_Logging.html#customizing-logging).

We need to add the following to add custom logging, which we can then read the tomcat logs to read the output:

{% tabs %}
{% tab title="Properties" %}
{% code lineNumbers="true" %}

```properties
########### Custom Appenders
log4j.logger.com.apryse.pdfnet.ss=DEBUG, APRYSE_PLUGIN

###### Custom Logging file appender
log4j.appender.APRYSE_PLUGIN=org.apache.log4j.RollingFileAppender
log4j.appender.APRYSE_PLUGIN.layout=org.apache.log4j.PatternLayout
log4j.appender.APRYSE_PLUGIN.layout.ConversionPattern=%d [%t] %-5p %c - %m%n
log4j.appender.APRYSE_PLUGIN.File=${AE_LOGS}/pdfnet_ss.log
log4j.appender.APRYSE_PLUGIN.MaxFileSize=10MB
log4j.appender.APRYSE_PLUGIN.MaxBackupIndex=1000
log4j.appender.APRYSE_PLUGIN.encoding=UTF-8
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/appian/smart-services/logging.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
